/* global cfg, Port, Tabs */
'use strict';

cfg.getItem('cfg', function(v) {
	var xhr = new XMLHttpRequest;
	xhr.overrideMimeType('application/json;charset=utf-8');
	xhr.open('GET', 'defaults.jsn', true);
	xhr.onload = function() {
		var def_prefs = JSON.parse(this.responseText);
		var need_update = false;
		v =	v ? JSON.parse(v) : {};

		for (var p in def_prefs) {
			if (v[p] === void 0) {
				v[p] = def_prefs[p];
				need_update = true;
			}
		}

		if (need_update) {
			cfg.setItem('cfg', JSON.stringify(v));
		}
	};
	xhr.send();
});

function onMessage(ev, origin, postMessage) {
	var e = Port.parseMessage(ev, origin, postMessage);
	var msg = e.msg;

	if (!msg.cmd) {
		return;
	}

	switch (msg.cmd) {
		case 'hello':
			cfg.getItem('cfg', function(v) {
				e.postMessage({
					cmd: 'hello',
					prefs: v
				});
			});
		break;

		case 'load_prefs':
			cfg.getItem('cfg', function(v) {
				e.postMessage({cfg: JSON.parse(v), app: app});
			});
		break;

		case 'save':
			cfg.setItem('cfg', JSON.stringify(msg.prefs));
		break;

		case 'open':
			if (!Array.isArray(msg.url)) {
				msg.url = [msg.url];
			}

			Tabs.getSelected(function(tab) {
				for (var i = 0; i < msg.url.length; ++i) {
					Tabs.create({
						incognito: !!tab.incognito,
						url: msg.url[i],
						active: !msg.nf
					});
				}
			});
		break;

		case 'load_frames.js':
			msg = new XMLHttpRequest;
			msg.overrideMimeType('text/plain;charset=utf-8');
			msg.open('GET', 'js/frames.js', true);
			msg.onload = function() {
				e.postMessage({'frames.js': this.responseText});
			};
			msg.send();
		break;
	}

	return true; // Chrome
}

Port.listen(onMessage);
